<?php
// misc functions. This include file should not exist...

// functions

function imap_and_query($query) // return string to pass to imap search
{
	$arr = split(" ", $query);
	foreach ($arr as $s) {
		$imapq=$imapq."TEXT ".$s." ";
	}
	return trim($imapq);
}

function get_mime_type(&$structure) 	// php manual / cleong at organic dot com
{ 
   	$primary_mime_type = array("TEXT", "MULTIPART","MESSAGE", "APPLICATION", "AUDIO","IMAGE", "VIDEO", "OTHER");
   	if($structure->subtype) {
   		return $primary_mime_type[(int) $structure->type] . '/' .$structure->subtype;
   	} else {
		return "TEXT/PLAIN";
	}
}

function get_part($stream, $msg_number, $mime_type, $structure = false,$part_number = false) 
{
	// php manual / cleong at organic dot com
   	if(!$structure) {
   		$structure = imap_fetchstructure($stream, $msg_number);
   	}
   	if($structure) {
		if($mime_type == get_mime_type($structure)) {
   			if(!$part_number) {
   				$part_number = "1";
   			}
   			$text = imap_fetchbody($stream, $msg_number, $part_number);
   			if($structure->encoding == 3) {
   				return imap_base64($text);
   			} else if($structure->encoding == 4) {
   				return imap_qprint($text);
   			} else {
   			return $text;
   			}
   		}
   
		if($structure->type == 1) /* multipart */ {
			while(list($index, $sub_structure) = each($structure->parts)) {
				if($part_number) {
					$prefix = $part_number . '.';
				}
				$data = get_part($stream, $msg_number, $mime_type, $sub_structure,$prefix .    ($index + 1));
				if($data) {
					return $data;
				}
			} // END OF WHILE
		} // END OF MULTIPART
	} // END OF STRUTURE
	return false;
} // End of php manual / cleong at organic dot com

function attachment_name($conn, $msg_no, $part) 
{
	$s="Untitled_attachment";
	$bodystruct = imap_bodystruct($conn, $msg_no, $part);
	$params = $bodystruct->parameters;
	for ($i=0; $i<2; $i++) {
        	if ($params[$i]->attribute == "NAME") $s=$params[$i]->value;
	}
#	$s = imap_utf8($s);
	return $s;
}

function attachment_links($conn, $folder, $msg_no) { // return str containing html with link to attachments except text/plain 1
	$s="";
	$struct = imap_fetchstructure($conn, $msg_no);
	$contentParts = count($struct->parts);
	if ($contentParts>=2) {
		for ($j=2; $j<=$contentParts; $j++) {
			$bodystruct = imap_bodystruct($conn, $msg_no, $j);
			$uid = imap_uid ($conn, $msg_no);
			$size = size2human($bodystruct->bytes);	
			$aname = attachment_name($conn, $msg_no, $j);
			$s = $s . "<a href=\"index.php?action=download&amp;folder=$folder&amp;uid=$uid&amp;part=$j&ampattachment=".urlencode($aname)."\">".str_web($aname)."</a> ($size) ";
		}
	}
	return $s;
}

function suffix2content_type($suffix)	// takes ".pdf", returns "application/pdf"
{
   	$content_type = "application/octet-stream";
	$types = array (
		".asf" => "video/x-ms-asf",
		".avi" => "video/avi",
		".doc" => "application/msword",
		".zip" => "application/zip",
		".xls" => "application/vnd.ms-excel",
		".gif" => "image/gif",
		".jpg" => "image/jpeg",
		".wav" => "audio/wav",
		".mp3" => "audio/mpeg3",
		".mpg" => "video/mpeg",
		".rtf" => "application/rtf",
		".htm" => "text/html",
		".html" => "text/html",
		".xml" => "text/xml",
		".xsl" => "text/xsl",
		".css" => "text/css",
		//".php" => "text/php",
		//".asp" => "text/asp",
		".pdf" => "application/pdf"						
	);
	$content_type = $types[$suffix];
	return $content_type;	
}

function view_part($conn, $msgno, $part) { // creates new page showing part for viewing/downloading
	$name = imap_utf8(attachment_name($conn, $msgno, $part));
	$suffix = strrev(substr(strrev($name),0,4));
	$content_type = suffix2content_type($suffix);
	$fileContent = imap_fetchbody($conn,$msgno,$part);

   	header ("Content-Type: $content_type"); 
   	header ("Content-Disposition: attachment; filename=$strFileName");    
   	echo imap_base64($fileContent);
}

function msg_source($conn, $msgno) // return str full headers and message source 
{
	$s = "";
	for ($i=0; $i<=2; $i++)	// todo: show all ($i>2) parts
		$s = $s.imap_fetchbody($conn, $msgno, $i);
	return $s;
}

function ago($thetime)
{
	// todo: dates in future
        $secs = time()-$thetime;
        if ($secs < 60*5)
                { $str = "less than 5 minutes ago"; }
        if ($secs < 60*60)
                { $str = round($secs/60,0) . " minutes ago"; }
        elseif ($secs < 60*60*1.5)
                { $str = "1 hour ago"; }
        elseif ($secs < 60*60*24)
                { $str = round($secs/60/60,0) . " hours ago"; }
        elseif ($secs < 60*60*24*5)     // 5 days
                { $str = round($secs/60/60/24,0) . " days ago"; }
        else
                { $str = date("Y-m-d D H:i",$thetime); }
        return "$str";
}

?>
