<?php

function str_word($s)	// return word chars (A-Z, a-z, 0-9, "_") and hypens ("-") of string
{
	return preg_replace("/[^\w-]/","",$s);
}

function str_web($s)	// returns $s in a form for display on web
{			// still problems with bodies, which are not
			// does not work with msgs already utf8?
	// conversion only works utf8_encode first, imap_utf8 second
	// todo: these character conversions are so lost...
	$s = utf8_encode($s); // works for body
	$s = imap_utf8($s); // works for subject
	$s = htmlentities($s, ENT_QUOTES, "utf-8");
	$s = strip_tags($s);	// just to make sure
	return $s;
}

function abstract($s, $len) // returns short preview version of email message
{
	$s = dos2unix($s);
	$s = preg_replace("/.*:\n{1,2}>.*/","",$s); // no quoted name
	$s = preg_replace("/>.*/","",$s); // no comments
	$s = preg_replace("/([,]){2,}/",'$1',$s); // !!! is no more than !
	$s = preg_replace("/[\.\-\_\*]{4,}/","...",$s); 
	// replace multiple occurrencies of non-alphanumerics with single
	$s = substr($s,0,$len);	// todo: strip @*:$^> and ^> 
	return $s;
}

function dos2unix($s) // return string with newlines changed to \n
{
	$s = str_replace("\n\r","\n",$s);
	$s = str_replace("\r","",$s);
	return $s;
}

function size2human($n) // takes int $n bytes, returns human readable string, such as "57 M" 
{ 			// todo: check results for correctness
	$b = log($n) / log(1024);	// x = logarith of $n with base 1024 <=> 1024**x=$n
	$size_short = array("k", "M", "G", "T", "P", "E"); 
	$size_long = array("kilo", "mega", "giga", "tera", "peta", "eksa");
	$measure = $size_short[floor($b-1)]."B"; // -1 because array starts from 0
	$s = round ($n / pow(1024, floor($b)), 1) ." ".$measure;
	return $s;
}

function quote($s) { // return string wrapped and quoted with  >
        $quote_mark="> ";
        if (""==$s) return "";

        $s = dos2unix($s);
        $s = preg_replace("/\n\n+/","=CHAPT=",$s);
        $s = str_replace("=CHAPT=","\n\n",$s);

        $s = wordwrap($s,69+2); // count "> " to target width
        $s = str_replace("\r","\n",$s);
        $s = $quote_mark.$s;
        $s = str_replace("\n","\n".$quote_mark,$s);
        return $s;
        // todo: find readymade function, don't quote signature
}
                                                                      
function header_encode($s) { // encode string for email header, as described in rfc2047
	// todo: max length of encoded-word is 75 chars. 
	// Headers with multiple encoded-words (>75 chars) will not be supported
	// Always use human-readable ?q?, never ?b? =20 == " "
	$s = utf8_decode($s); // utf8 to iso-8859-1
	$s = imap_8bit($s); // iso-8859-1 to quoted-printable, except spaces
	$s = preg_replace("/\s/","=20",$s); // encoded-text must not contain white-space
	$s = "=?iso-8859-1?Q?".$s."?="; // encoded-word
	return $s;
}

function address_encode($address_list) { // encode real-name part of to/cc/bcc/from addresses if needed
	
	$address_array  = imap_rfc822_parse_adrlist($address_list,"localhost");
	if(! is_array($address_array)) echo("Address parsing failed.\n"); 
		
	reset($address_array);
	while(list($key,$val)=each($address_array)){
		if ( preg_match("/[^\033-\127]/", $val->personal) ) { // todo: check actual us-ascii values
			$s = $s . header_encode($val->personal);
		} else {
			$s = $s . $val->personal;
		}
		if ( strlen($val->personal)>0 ) {
			$s = $s . " <".$val->mailbox."@".$val->host.">, ";			
		} else {
			$s = $s . "".$val->mailbox."@".$val->host.", ";
		}
		// echo "adl :".$val->adl."<br />"; // what is this "at domain source route"?
	}
	$s = preg_replace("/, $/", "", $s);
	return $s;
}
?>
